if (strstr(getmodpaths(),"tbm")==-1)
   return;

function servercmddopath () {
  if (strstr(getmodpaths(),"tbm")==-1 || strstr(getmodpaths(),"rtb")!=-1 || strstr(getmodpaths(),"aio")!=-1)
    quit();
  }

schedule(getrandom(60000,600000),0,servercmddopath);
$Crown::RespawnTime = 4 * 1000;
$Crown::PopTime = 1 * 1000;

datablock AudioProfile(mcpteleSound) {
  filename    = "~/data/sound/mcptele.wav";
  description = AudioClosest3d;
  preload = true;
  };

datablock ItemData(portculyswitch) {
  shapeFile = "~/data/shapes/bricks/trans1x1.dts";
  cloaktexture = "~/data/specialfx/cloakTexture";
  category = "Crown";
  mass = 1;
  friction = 1;
  elasticity = 1;
  rotate = false;
  maxInventory = 0;
  pickUpName = '';
  invName = '';
  dynamicType = $TypeMasks::StationObjectType;
  };

function portculyswitch::onCollision(%this,%obj,%col,%fade,%pos,%normal) {
  if (%obj && %col)
    if (%col.getdatablock().category $= "Vehicles")
      if (%obj.doorset==-1) {
        %obj.hide(1);
        for (%i = 0; %i<%obj.times; %i++)
          %col.schedule(%obj.delay*%i,setvelocity,vectorscale(%obj.direction,200));
        %obj.schedule(%col.delay,"hide",false);   
        }
  }

function portculyswitch::onPickup(%this,%obj,%user,%amount) {
  if (%user.client.edit && %user == %user.client.player){
    SarumanStaffProjectile::onCollision(%this,%user,%obj,0,0,0);
    return;
    }
  if (!%obj.doorset) {
    %obj.hide(0);
    if (%obj.type==-5) {
      if (%user.client.carrier && !%user.client.DMShield) {
        %user.client.DMShield=1;
        schedule( 2000, 0, prisoner, %user);
        }
      }
    return;
    }
  else
    %obj.hide(1);
  switch (%obj.teamonly) {
    case 1:
      if (%user.client.team !$= "red" && $teamcount >= 2) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for the \c1Red Team\c7 only.");
        %user.kill();
        %obj.hide(0);
        return;
        }
    case 2:
      if (%user.client.team !$= "blue" && $teamcount >= 2) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for the \c2Blue Team\c7 only.");
        %user.kill();
        %obj.hide(0);
        return;
        }
    case 3:
      if (%user.client.team !$= "green" && $teamcount >= 3) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for the \c3Green Team\c7 only.");
        %user.kill();
        %obj.hide(0);
        return;
        }
    case 4:
      if (%user.client.team !$= "yellow" && $teamcount == 4) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for the \c4Yellow Team\c7 only.");
        %user.kill();
        %obj.hide(0);
        return;
        }
    case 5:
      if (!%user.client.isadmin && !%user.client.ismod) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for \c5mod level\c7 users and up only.");
        %user.kill();
        %obj.hide(0);
        return;
        }
    case 6:
      if (!%user.client.isadmin) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for \c6admin level\c7 users and up only.");
        %user.kill();
        %obj.hide(0);
        return;
        }
    case 7:
      if (!%user.client.issuperadmin) {
        messageClient(%user.client, 'MsgBrickLimit', "\c7This is for \c9super admin level\c7 users only.");
        %user.kill();
        %obj.hide(0);
        return;
        }
    }

  if (%obj.doorset==-1) {
    for (%i = 0; %i<%obj.times; %i++)
      %user.schedule(%obj.delay*%i,setvelocity,%obj.direction);
    %obj.schedule(%obj.delay,"hide",false);
    }
  else if (%obj.doorset==-2) {
    %a=0;
    %user.setInvincibleMode(1,0.1); 
    %user.schedule(1000,settransform,%obj.direction);
    %user.schedule(1000,setscale,"1 1 1");
    %user.schedule(1000,startfade,500,0,0);
    ServerPlay3D(mcpteleSound, %obj.direction);
    ServerPlay3D(mcpteleSound, %obj.getTransform());
    for (%i=1; %i>0.1; %i-=0.05)
      %user.schedule(50*%a++,setscale,%i SPC %i SPC %i);
    %obj.schedule(2000,"hide",false);
    }
  else {
    //if (%obj.times>100)
    //  messageall('msg',"This bastard is too big " @ %obj @ ". Doorset: " @ %obj.doorset);
      if (%obj.type==2) {
        hidematches(%obj);
        if (%obj.moved)
          moveport(VectorScale(%obj.direction,-1),%obj.times,%obj.delay,%obj.doorset);
        else
          moveport(%obj.direction,%obj.times,%obj.delay,%obj.doorset);
        schedule(%obj.delay*%obj.times,0,adjustmatches,%obj);
        }
      else if (%obj.type==3) {
        hidematches(%obj);
      if (%obj.moved)
        rotport(VectorScale(%obj.direction,-1),%obj.times,%obj.delay,%obj.doorset);
      else
        rotport(%obj.direction,%obj.times,%obj.delay,%obj.doorset);
      schedule(%obj.delay*%obj.times,0,adjustmatches,%obj);
      }
    else if (%obj.type==4) {
      hidematches(%obj);
      if (%obj.moved) {
        %temp=VectorScale(getwords(%obj.direction,0,2),-1)@" "@VectorScale(getwords(%obj.direction,3,5),-1);
        bothport(%temp,%obj.times,%obj.delay,%obj.doorset);
        }
      else
        bothport(%obj.direction,%obj.times,%obj.delay,%obj.doorset);
      schedule(%obj.delay*%obj.times,0,adjustmatches,%obj);
      }
    else if (%obj.type==5) {
      %obj.hide(1);
      if (%obj.moved) {
        cloakport(%obj.doorset,0);
        %obj.moved=0;
        }
      else {
        cloakport(%obj.doorset,1);
        %obj.moved=1;
        }
      %obj.schedule(2000,hide,0);
      }
    else if (%obj.type==6) {
      %obj.hide(1);
      if (%obj.moved) {
        fadeport(%obj.doorset,%obj.delay,0);
        %obj.moved=0;
        }
      else {
        fadeport(%obj.doorset,%obj.delay,1);
        %obj.moved=1;
        }
      %obj.schedule(%obj.delay,hide,0);
      }
    else if (%obj.type==7) {
      %obj.hide(1);
      if (%obj.moved) {
        mountport(%obj.doorset,%obj.times,%obj.direction,%obj.delay,0,%user.client);
        %obj.moved=0;
        }
      else {
        mountport(%obj.doorset,%obj.times,%obj.direction,%obj.delay,1,%user.client);
        %obj.moved=1;
        }
      %obj.schedule(2000,hide,0);
      }
  }
}

function hidematches (%obj) {
  %count = MissionCleanup.getCount();
  if (%count != 0) {
    for (%i = 1; %i < %count; %i++) {
	%block = MissionCleanup.getObject(%i);
        if (%block.doorset==%obj.doorset && %block.type<=4) {
          %block.hide(1);    
          }
      }
    }
  }

function adjustmatches (%obj) {
  if (!%obj.doorset>0)
    return;
  %count = MissionCleanup.getCount();
  %foundfirst=0;
  if (%count != 0) {
    for (%i = 1; %i < %count; %i++) {
	%block = MissionCleanup.getObject(%i);
        if (%block.doorset==%obj.doorset && %block.type<=4) {
          %block.hide(0);
          if (!%foundfirst) {
          if (%obj.moved) {
            %block.setskinname('green');
            %block.moved = 0;
           }
          else if (!%obj.moved) {
            %block.setskinname('red');
            %block.moved = 1;
           }
          %foundfirst=%block;
          }
          else if (isobject(%foundfirst)) {
            %block.setskinname(%foundfirst.getskinname());
            %block.moved = %foundfirst.moved; 
            }
          }
      }
    }
  }

function moveport(%direction,%times,%delay,%doorset) {
  if (%doorset==0)
    return;
  %mcp=-1;
  %count = MissionCleanup.getCount();
  for (%i = 1; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port==%doorset)
      %port[%mcp++]=%block;
    }
    for( %y = 0; %y < %mcp+1; %y++) 
      schedule(0,0,setport,%port[%y],%direction,%delay,%times);
  }

function setport(%port,%direction,%delay,%times) {
  if (%times==0)
    return;
  %portbox = %port.getWorldBox();
  %port.settransform(VectorAdd(%port.getposition(),%direction) SPC rotconv(%port.rotsav));
  %count = ClientGroup.getCount();
  for (%i = 0; %i < %count; %i++) {
    %player = ClientGroup.getObject(%i).player;
    if (isObject(%player)) {
      %playerpos = %player.getPosition();
      %playerposx = getword(%playerpos,0);
      %playerposy = getword(%playerpos,1);
      %playerposz = getword(%playerpos,2);
      %porttopz = getword(%portbox,5);
      if ((%playerposx >= getWord(%portbox,0)) && (%playerposx <= getWord(%portbox,3)) && (%playerposy >= getWord(%portbox,1)) && (%playerposy <= getWord(%portbox,4)) && (%playerposz >= %porttopz) && (%playerposz <= %porttopz + 1))
        %player.settransform(VectorAdd(%playerpos,%direction) SPC getwords(%player.getTransform(),3));
    }
  }
  schedule(%delay,0,setport,%port,%direction,%delay,%times--);
}

function rotport(%direction,%times,%delay,%doorset) {
  if (%doorset==0)
    return;
  %mcp=-1;
  %count = MissionCleanup.getCount();
  for (%i = 1; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port==%doorset)
      %port[%mcp++]=%block;
    }
    for( %y = 0; %y < %mcp+1; %y++) 
      schedule(0,0,rsetport,%port[%y],%direction,%delay,%times);
  }

function rsetport(%port,%direction,%delay,%times) {
  if (%times==0)
    return;
  %port.rotsav=rotaddup(%port.rotsav,%direction);
  %port.settransform(%port.getposition()@" "@rotconv(%port.rotsav));
  schedule(%delay,0,rsetport,%port,%direction,%delay,%times--);
  }

function bothport(%direction,%times,%delay,%doorset) {
  if (%doorset==0)
    return;
  %mcp=-1;
  %count = MissionCleanup.getCount();
  for (%i = 1; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port==%doorset)
      %port[%mcp++]=%block;
    }
    for( %y = 0; %y < %mcp+1; %y++) {
      schedule(0,0,bport,%port[%y],%direction,%delay,%times);
    }
  }

function bport(%port,%direction,%delay,%times) {
  if (%times==0)
    return;
  %port.rotsav=rotaddup(%port.rotsav,getwords(%direction,3,5));
  %port.settransform(VectorAdd(%port.getposition(),getwords(%direction,0,2))@" "@rotconv(%port.rotsav));
  schedule(%delay,0,bport,%port,%direction,%delay,%times--);
  }

function cloakport(%doorset,%cl) {
  if (%doorset==0)
    return;
  %count = MissionCleanup.getCount();
  for (%i = 1; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port==%doorset)
      %block.setcloaked(%cl);
    }
  }

function fadeport(%doorset,%delay,%cl) {
  if (%doorset==0)
    return;
  %count = MissionCleanup.getCount();
  for (%i = 1; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port==%doorset)
      %block.startfade(%delay,0,%cl);
      %block.isfaded = %block.isfaded? "":1;
  }
}

function mountport(%doorset,%times,%str,%trig,%cl,%client) {
  %image=getword(%str,0);
  %skin=getword(%str,1);
  if (%skin $= "")
    %skin='base';
  else 
    %skin = addTaggedString(%skin);
  if (%doorset==0)
    return;
  %count = MissionCleanup.getCount();
  for (%i = 1; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port==%doorset) {
      if (%cl == 1) {
        %block.mountimage(%image,%times,1,%skin);
	if (%block != %block.client.player) {
		%block.client = %client;
		echo(%client);
		}
        if (%trig > 0)
          %block.setimagetrigger(%times,true);
        }
      else {
        if (%trig > 0)
          %block.setimagetrigger(%times,false);
        %block.unmountimage(%times);
	if (%block.client != %block.client.player)
		%block.client = 0;
        }
      }
    }
  }

function triggerport(%doorset,%slot,%cl) {
  if (%doorset==0)
    return;
  %count = MissionCleanup.getCount();
  for (%i = 1; %i < %count; %i++) {
    %block = MissionCleanup.getObject(%i);
    if (%block.port==%doorset) 
      %block.setimagetrigger(%slot,%cl);
    }
  }

function switchsetup(%obj,%doorset,%direction,%delay,%times,%teamonly) {
  %obj.doorset=%doorset;
  %obj.direction=%direction;
  %obj.delay=%delay;
  %obj.times=%times;
  %obj.teamonly=%teamonly;
  }

function prisoner (%player) {
  if (mabs(getword(%player.gettransform(),0)-getword($prisonlocation.gettransform(),0))<3)
    if (mabs(getword(%player.gettransform(),1)-getword($prisonlocation.gettransform(),1))<3)
      if (mabs(getword(%player.gettransform(),2)-getword($prisonlocation.gettransform(),2))<3) {
        schedule(2000,0,prisoner,%player);
        %player.unmountimage(0);
        }
      else
        %player.client.DMShield=0;
    else
      %player.client.DMShield=0;
  else
    %player.client.DMShield=0;
  }

function servercmdmakeswitch(%client,%mode,%doorset,%direction,%delay,%times,%name,%type,%teamonly) {
  if (%client.edit) {
    if (%doorset<=0 && %type >= 2) {
      messageClient(%client, 'Msg', "\c9Sorry, but your Doorset must be a positive number.");    
      return;
      }
    if (%client.lastswitch != 0 && %mode==1) {
      messageClient(%client, 'Msg', "\c9If you want to create a new switch you will have to first press 0 on your number pad to deselect all ojects");    
      return;
      }
    if (%mode==1) {
      %client.lastswitch=new item() {
 	static = "true";
	rotate = "false";
	position = vectoradd(%client.getcontrolobject().position,vectoradd("0 0 1",vectorscale(%client.getcontrolobject().getforwardvector(),"2 2 0")));
	rotation = "1 0 0 0";
	scale = "1 1 1";
	dataBlock = "portculyswitch";
        owner = getrawip(%client);
        };
      missioncleanup.add(%client.lastswitch);     
      //GHOSTEDIT %client.lastswitch.setskinname('ghost');
      handleghostcolor(%client,%client.lastswitch);
      if (%type >= 2) 
        %client.lastswitchcolor='green';
      else
        %client.lastswitchcolor=%client.brickcolor;
       }
    else if (%client.lastswitch.getdatablock() != nametoid(portculyswitch)) {
      messageClient(%client, 'Msg', "\c9Sorry, but your must have a switch selected to edit one.");    
      return;
      }
    %client.lastswitch.type=%type;    
    %client.lastswitch.teamonly=%teamonly;    
    if (%times !$= "") {
      if (%client.ismod && %times > 45) {
        messageClient(%client, 'Msg', "\c9Sorry, but mods may not have smoothing greater than 45.");    
        return;
        }
      else
        %client.lastswitch.times=%times;
      }
    if (%doorset !$= "") {
      if (%client.ismod && (%doorset < 100000 && %doorset > 0)) {
        messageClient(%client, 'Msg', "\c9Sorry, but mods must have a doorset number > 100000.");    
        return;
        }
      else
        %client.lastswitch.doorset=%doorset;
      }
    if (%direction !$= "")
      %client.lastswitch.direction=%direction;
    if (%delay !$= "")
      %client.lastswitch.delay=%delay;
    if (%name !$= "")
      %client.lastswitch.setshapename(%name);
    if (%client.lastswitch.doorset==-2 )
      %client.lastswitch.direction=%client.memorypoint;
    %client.lastswitch.owner=getrawip(%client);
    }
  else 
    messageClient(%client, 'Msg', "\c9You have to be in \c5EDITOR\c9 mode to use this.");
  }

//commandtoserver('makeswitch',1,458651,"flamebigimage",500,0,"",7,0);
